class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
        self.prev = None
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self,newdata):
        self.data = newdata
    def setNext(self,newnext):
        self.next = newnext
    def getPrev(self):
        return self.prev
    def setPrev(self,newprev):
        self.prev = newprev

class UnorderedList:
    def __init__(self):
        self.head = None
        self.tail = None
    def add(self,item):
        temp = Node(item)
        if self.head == None:
            self.head = temp
            self.tail = temp
        else:
            self.head.setPrev(temp)  
            temp.setNext(self.head)
            self.head = temp
    def size(self):
        current = self.head
        count = 0
        while current != None:
            count = count + 1
            current = current.getNext()
        return count
    def append(self,item):
        temp = Node(item)
        if self.tail == None:
            self.head = temp
            self.tail = temp
        else:
            self.tail.setNext(temp)
            temp.setPrev(self.tail)
            self.tail = temp
    def index(self,item):
        current = self.head
        count = 0
        while current!= None:
            if current.getData() == item:
                return count
            else:
                current = current.getNext()
                count = count + 1
        return False
    def pop(self):
        temp = self.tail
        previous = self.tail.getPrev()
        previous.setNext(None)
        self.tail = previous
        return temp
    def insert(self,num,item):
        temp = Node(item)
        current = self.head
        count = 0
        previous = None
        while count != num:
            previous = current
            current = current.getNext()
            count = count + 1
        if current == self.head:
            current.setPrev(temp)
            temp.setNext(current)
            self.head = temp
        elif current == self.tail:
            current.setNext(temp)
            temp.setPrev(current)
            self.tail = temp
        else:
            temp.setNext(current)
            previous.setNext(temp)
            temp.setPrev(previous)
            current.setPrev(temp)
    
