# -*- coding： utf-8 -*-
#------------------------------------NO.1------------------------------------
class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self,newdata):
        self.data = newdata
    def setNext(self,newnext):
        self.next = newnext
class UnorderList:
    def  __init__(self):
        self.head = None
    def isEmpty(self):
        return self.head == None
    def size(self):
        current = self.head
        count = 0
        while current!= None:
            count = count +1
            current = current.getNext()
        return count
    def append(self,item):
    #往链表最后加一个数，利用循环遍历到使previous为最后一个节点，然后加节点
    #原链表为空特殊考虑
        previous = None
        current = self.head
        while current != None:
            previous = current
            current = current.getNext()
        temp = Node(item)
        if(previous == None):
            self.head = temp
        else:
            temp.setNext(current)
            previous.setNext(temp)
    def index(self,item):
    #遍历链表看当前项的值是否与item相同
        num = 0
        current = self.head
        found = False
        while current !=None and not found:
            if current.getData()== item:
                found = True
            else:
                num += 1
                current = current.getNext()
        if found:
            return num
        else:
            return 'None'
    def pop(self):
    #删除链表最后一项，遍历到最后使previous为倒数第二项，current为倒数第一项
    #链表仅有一项特殊考虑
        current = self.head
        previous = None
        while current.getNext() != None:
            previous = current
            current = current.getNext()
        if previous == None :
            self.head = current.getNext()
        else:
            previous.setNext(current.getNext())
        return current.getData()
    def popn(self,n):
    #删除第n项。循环使previous为目标项的前一项，current为目标项
        num = 0
        current = self.head
        previous = None
        while num<n :
            previous = current
            current = current.getNext()
            num +=1
        if previous == None:
            self.head = current.getNext()
        else:
            previous.setNext(current.getNext())
        return current.getData()
    def insert(self,n,item):
    #在第n项插入item。循环结果使current为原链表第n项，previous为原链表第n-1项
    #当n为0时特殊考虑
        num = 0
        current = self.head
        previous = None
        while num < n:
            previous = current
            current = current.getNext()
            num += 1
        temp = Node(item)
        if (previous == None):
            temp.setNext(self.head)
            self.head = temp
        else:
            temp.setNext(current)
            previous.setNext(temp)
    def __str__(self):
    #转换为字符串。将链表中的值添加到一个列表中，将列表转换为字符串
        strlist = []
        current = self.head
        while current!= None:
            strlist.append(current.getData())
            current = current.getNext()
        return ''.join(strlist)
    def __getitem__(self, n): #切片
        myslice = []
        current = self.head
        if isinstance(n, int): #得到某一位置的节点的值
            for i in range(n):
                myslice.append(current.getData())
                current = current.getNext()
            return current.getData()
        if isinstance(n, slice):  #得到一个切片
            num = n.step  #步幅
            start = n.start
            stop = n.stop
            if not isinstance(start,int):  #如果没有输入起始的数字
                start = 0
            if not isinstance(stop,int):  #如果没有输入结束的数字
                stop = self.size()
            if not isinstance(num, int):  #如果没有输入步幅
                num = 1
            if(start<0):  #如果起始的数字是负数
                start += self.size()
            if(stop<0):   #如果结束的数字是负数
                stop += self.size()
            i = 0
            while i < stop :
                if (i >= start):
                    myslice.append(current.getData())
                for j in range(num):
                    current = current.getNext()
                i = i + num
            return myslice
mylist = UnorderList()
for i in range(10,16):
    stri = str(i)
    mylist.append(stri)
mylist.insert(0,'17') #链表为  17 10 11 12 13 14 15
print('-----------NO.1------------')
print(mylist.index('13'))
print(mylist.__str__())
print(mylist[:-1:2])
print(mylist.pop())
print(mylist.popn(1))
#-----------------------------------------------NO.2-------------------------------------
class Stack:
    def __init__(self):
        self.items = UnorderList()
    def isEmpty(self):
        return self.items.isEmpty()
    def push(self,item):
        self.items.append(item)
    def pop(self):
        return self.items.pop()
    def peek(self): #循环到最后一项再返回其数值
        current = self.items.head
        sum = self.items.size()
        for i in range(sum-1):
            current = current.getNext()
        return current.getData()
    def size(self):
        return self.items.size()
class Queue:
    def __init__(self):
        self.items = UnorderList()
    def isEmpty(self):
        return self.items.isEmpty()
    def enqueue(self,item):
        self.items.insert(0,item)
    def dequeue(self):
        return self.items.pop()
    def size(self):
        return self.items.size()
print('----------NO.2----------')
s = Stack()
for i in range(10):
    s.push(i)      #栈中元素 0 1 2 3 4 5 6 7 8 9
print(s.isEmpty())
print(s.size())
print(s.peek())
print(s.pop())
q = Queue()
for i in range(10,20):
    q.enqueue(i)   #队列元素 10 11 12 13 14 15 16 17 18 19
print(q.isEmpty())
print(q.size())
print(q.dequeue())
#-----------------------------------------------NO.3------------------------------------------
class NewNode: #双向节点
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
        self.prev = None #添加prev变量
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self,newdata):
        self.data = newdata
    def setNext(self,newnext):
        self.next = newnext
    def getPrev(self): #添加找节点前一项的函数
        return self.prev
    def setPrev(self,newprev): #添加建立节点前一项的函数
        self.prev = newprev
class NewUnorderList:
    def __init__(self):
        self.head = None
        self.tail = None #代表链表中最后一个节点
    def isEmpty(self):#与单项列表相同
            return self.head == None#
    def size(self):#与单项列表相同
        current = self.head
        count = 0
        while current != None:
            count = count + 1
            current = current.getNext()
        return count
    def search(self,item):#与单项列表相同
        current = self.head
        found = False
        while current != None and not found:
            if current.getData() == item:
                found  = True
            else:
                current = current.getNext()
        return found
    def index(self, item):#与单项列表相同
        num = 0
        current = self.head
        found = False
        while current != None and not found:
            if current.getData() == item:
                found = True
            else:
                num += 1
                current = current.getNext()
        if found:
            return num
        else:
            return 'None'
    def add(self, item):
    #往链表前端加item。若原链表为空，则头尾均为新节点。
        temp = NewNode(item)
        if (self.tail == None):
            self.tail = temp
        else:
            temp.setNext(self.head)
            self.head.setPrev(temp)
        self.head = temp
    def remove(self, item):
    #除去数值为item的项。
        current = self.head
        previous = None
        found = False
        while not found:
            if current.getData() == item:
                found = True
            else:
                previous = current
                current = current.getNext()
        if previous == None: #若要去除第0项
            self.head = current.getNext()
            if self.size() == 0: #若去除后链表为空
                self.tail = None
            else :  #若去除后不为空
                self.head.setPrev(None)
        else:
            previous.setNext(current.getNext())
            if current.getNext() != None:
                current.getNext().setPrev(previous)
            else:    #如果删去的是最后一项
                self.tail = previous
    def append(self, item):
    #往链表最后加值为item的节点。考虑原链表为空的情况。
        temp = NewNode(item)
        if (self.head == None):
            self.head = temp
        else:
            temp.setNext(self.tail.getNext())
            temp.setPrev(self.tail)
            self.tail.setNext(temp)
        self.tail = temp
    def insert(self, pos, item): #往链表中pos位置加入节点。考虑往第一个位置和最后一个位置加的特殊情况
        num = 0
        current = self.head
        previous = None
        while num < pos:
            previous = current
            current = current.getNext()
            num += 1
        temp = NewNode(item)
        if previous == None and self.size() == 0:  # 若往第0项加且原链表为空
            self.head = temp
            self.tail = temp
        elif previous == None and self.size() != 0:  # 若往第0项加且原链表不为空
            temp.setNext(self.head)
            self.head.setPrev(temp)
            self.head = temp
        else:
            temp.setNext(current)
            if current == None:  # 如果往最后一个位置加
                self.tail = temp
            else:
                current.setPrev(temp)
            previous.setNext(temp)
            temp.setPrev(previous)
    def pop(self):
    #删除并返回链表最后一项
        temp = self.tail
        if self.size()==1: #若原链表只有一项
            self.head = None
            self.tail = None
        else:
            self.tail.getPrev().setNext(None)
            self.tail = self.tail.getPrev()
        return temp.getData()
    def popn(self, pos):    #删除并返回链表第pos项
        num = 0
        current = self.head
        previous = None
        while num < pos:
            previous = current
            current = current.getNext()
            num += 1
        if previous == None and self.size() == 1:  # 若去掉第0项且原链表仅有一项
            self.head = None
            self.tail = None
        elif previous == None and self.size() != 1: # 若去掉第0项且原链表不止一项
            current.getNext().setPrev(None)
            self.head = current.getNext()
        else:
            previous.setNext(current.getNext())
            if current.getNext() != None :
                current.getNext().setPrev(previous)
            else :  #若去掉的是最后一项
                self.tail = previous
        return current.getData()
print('-----------NO.3----------')
mylist = NewUnorderList()
for i in range(10, 16):
    stri = str(i)
    mylist.add(stri)
mylist.insert(0, '17')
mylist.append('18')  # 1715141312111018
print(mylist.isEmpty())
print(mylist.search('18'))
print(mylist.index('13'))
mylist.remove('11')
print(mylist.size())
print(mylist.pop())
print(mylist.popn(5))