#定义链节
class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.Next = None
        self.Prev = None
    def getData(self):
        return self.data
    def getNext(self):
        return self.Next
    def getPrev(self):
        return self.Prev
    def setNext(self,item):
        self.Next = item
    def setPrev(self,item):
        self.Prev = item
    def setDate(self,item):
        self.data = item
#第一题单向链表实现UnorderedList的方法
class UnorderedListonedirection:
    def __init__(self):
        self.head = Node(None)
    def add(self,item):#添加项目到第一个位置
        temp = Node(item)
        temp.setNext(self.head.Next)
        self.head.Next = temp
    def remove(self,item):
        current = self.head
        while current.Next.getData() != item:  #找到要删除的链节的前一个链节
            current = current.Next
        current.Next = current.Next.Next  #将待删除的链节的前一个链节与后一个链节相连接
    def search(self,item):
        current = self.head
        found = False
        while current.Next!= None and found == False: #防止越界
            current = current.Next
            if current.getData() == item:
                found =True
        return found
    def isEmpty(self):
        if self.size() == 0:
            return True
        else:
            return False
    def size(self):
        current = self.head
        n = 0
        while current.getNext()!= None:
            current = current.getNext()
            n = n + 1
        return n
    def append(self,item):#添加项目到最后一个链节
        temp = Node(item)#要加入的链节
        current = self.head #用于找到链表的末端
        while current.Next != None:
            current = current.Next
        current.Next = temp
        temp.setNext(None)
    def index(self,item): #按数据项索引,从0开始
        n = 0
        current = self.head
        while current.Next.getData()!= item and current.getNext() != None:
            current = current.getNext()
            n = n + 1
        return n if  current.Next.getData() == item else False #如果越界返回false
    def insert(self,n,item):#接受两个参数,位置和插入的对象  从零计数
        current = self.head
        temp = Node(item)
        for i in range(n):#找到待插入位置的前一个链节
            current= current.getNext()
        temp.Next = current.Next
        current.Next =temp
    def pop(self):#复杂度为O(n) 删除最后一个
        if self.head.Next == None:#防止出现空链表，删除head
            return False
        else:
            current = self.head  #用于找到删除的链节的前一个链节
            while current.Next.Next != None:
                current = current.Next#找到倒数第二个链节或者 head
            data = current.Next.getData()  #在删除之前 暂存数据
            current.Next = None
            return data
    def pop(self,pos):
        len = self.size()
        current = self.head
        if pos >= len:
            return False#防止越界
        else:
            n = 0
            while n < pos - 1:
                current = current.Next
                n = n + 1
            data = current.Next.getData()
            current.Next = current.Next.Next
            return data
    def delete(self):#复杂度为 o(1)  删除第一个
        temp = self.head.getNext()  #要删除的链节
        data = temp.getData()
        if (temp != None): #防止删除head
            self.head.Next = temp.Next
        return data if data != None else False
#将负位置坐标转化为0或正数  用于切片
    def getlocation(self,num):
        if num < 0 and  -num <= self.size():
            n = self.size()
            return n+num
        elif num >= 0 and num < self.size():
            return num
        else:
            return False#越界的返回错误
    def getSlice(self,m,n):  #列表切片
        len = self.size()
        if(m >= len or n >= len or -m >len or -n > len): #防止越界
            return False
        else:
            m = self.getlocation(m)#将可能出现的负值位置先全部转化为正数或0
            n = self.getlocation(n)
            bow = UnorderedListonedirection()  #存放元素的容器
            if (m < n):
                b = n - m #要输出的个数#
                temp = self.head
                for i in range(m + 1):
                    temp = temp.getNext()
                for j in range(b):
                    bow.append(temp.getData())
                    temp = temp.getNext()
                return bow
            elif(m > n):
                b = m - n #要输出的个数#
                temp = self.head
                for i in range(n + 1):
                    temp = temp.getNext()#找到起点
                for j in range(b):
                    temp =temp.getNext()
                    bow.append(temp.getData())#顺序恰好相反
                bow2 = UnorderedListonedirection()
                while bow.size() != 0:
                    bow2.append(bow.pop())
                return bow2
            else:
                return False #防止出现切同一个位置，跨度为零的情况
    def str(self,list):
        bow = UnorderedListonedirection()
        for token in list:
            bow.append(token)
        return bow
h = UnorderedListonedirection()
h.append(1)
h.append(3)
h.append(5)
h.append(2)
h.remove(1)
h.add(1)
print(h.pop(0),h.size(),h.search(1),h.search(2),h.index(2))
i = h.getSlice(1,2)
print(i.size())
#第三题双向链表实现UnorderedList的方法
class UnorderedList:
    def __init__(self):
        self.head = Node(None)
        self.tail  = Node(None)
        self.head.Next = self.tail
        self.tail.Prev  = self.head
    def add(self,item):#添加项目到第一个位置
        temp = Node(item)
        self.head.Next.Prev = temp  #将待插入位置的后一个链节与该链节相连
        temp.setNext(self.head.Next)
        self.head.Next = temp #将head与该链节相连
        temp.Prev = self.head
    def remove(self,item):
        current = self.head
        while current.getData() != item:  #找到要删除的链节
            current = current.Next
        print(current.getData())
        current.Next.Prev = current.Prev  #将待删除的链节的前一个链节与后一个链节相连接
        current.Prev.Next = current.Next
    def search(self,item):
        current = self.head
        found = False
        while current.Next!= None and found == False: #防止越界
            current = current.Next
            if current.getData() == item:
                found =True
        return found
    def isEmpty(self):
        if self.size() == 0:
            return True
        else:
            return False
    def size(self):
        current = self.head
        n = 0
        while current.getNext()!= None:
            current = current.getNext()
            n = n + 1
        return n-1
    def append(self,item):  #双向链表不用考虑添加的元素是否位于开头结尾或中间，即添加的元素永远位于head 和 tail 的中间,复杂度为o(1)
        temp = Node(item)#要加入的链节
        self.tail.Prev.Next = temp  #将tail与待加入链节相连
        temp.setPrev(self.tail.Prev)#将待加入链节与tail相连
        self.tail.Prev = temp
        temp.setNext(self.tail)
    def delete(self):#复杂度为 o(1)  删除第一个
        temp = self.head.getNext()  #要删除的链节
        if (temp != self.tail): #防止删除tail
            temp.Next.Prev = self.head      #将倒数第二个字节与tail相连
            self.head.Next = temp.Next      #将tail与倒数第二个相连
        return temp.getData()
    def index(self,item): #按数据项索引,从0开始
        n = 0
        current = self.head
        while current.Next.getData()!= item and current.getNext() != None:
            current = current.getNext()
            n = n + 1
        return n if  current.Next.getData() == item else False #如果越界返回false
    def insert(self,n,item):#接受两个参数,位置和插入的对象  从零计数
        current = self.head
        temp = Node(item)
        for i in range(n):
            current= current.getNext()
        temp.setNext(current.getNext()) #将插入位置的后一个链节与待插入的链节相连
        current.Next.Prev = temp
        temp.setPrev(current)   #将插入位置的前一个链节与待插入的链节相连
        current.Next = temp
    def pop(self):#复杂度为O(1) 删除最后一个
        temp = self.tail.getPrev()  #要删除的链节
        if (temp != self.head): #防止删除head
            temp.Prev.Next = self.tail      #将倒数第二个字节与tail相连
            self.tail.Prev = temp.Prev      #将tail与倒数第二个相连
        return temp.getData()
    def pop(self,pos):
        len = self.size()
        current = self.head
        if pos >= len:
            return False#防止越界
        else:
            n = 0
            while n <= pos :
                current = current.Next
                n = n + 1
            data = current.getData()
            current.Next.Prev = current.Prev  #将待删除的链节的前一个链节与后一个链节相连接
            current.Prev.Next = current.Next
            return data

#将负位置坐标转化为0或正数  用于切片
    def getlocation(self,num):
        n =self.size()
        if num < 0 and  -num <= n:
            return n+num
        elif num > 0 and num < self.size():
            return num
    def getSlice(self,m,n):  #列表切片
        if(m >= self.size() or n >= self.size() or -m >self.size() or -n > self.size()): #防止越界
            return False
        else:
            m = self.getlocation(m)#将可能出现的负值位置先全部转化为正数或0
            n = self.getlocation(n)
            bow = UnorderedList()  #存放元素的容器
            if (m < n):
                b = n - m #要输出的个数#
                temp = self.head
                for i in range(m + 1):
                    temp = temp.getNext()
                for j in range(b):
                    bow.append(temp.getData())
                    temp = temp.getNext()
                return bow
            elif(m > n):
                b = m - n #要输出的个数#
                temp = self.head
                for i in range(m + 1):
                    temp = temp.getNext()#找到起点
                for j in range(b):
                    bow.append(temp.getData())
                    temp = temp.getPrev()
                return bow
    def str(self,list):
        bow = UnorderedList()
        for token in list:
            bow.append(token)
        return bow
a = UnorderedList()
a.append(123)
a.append(15)
a.append("abc")
a.append("xyz")
print(a.size(),a.pop(2),a.size())
#第二题定义stack
class Stack:
    def __init__(self):
        self.core = UnorderedList()
    def push(self,item):
        self.core.append(item)
    def pop(self):
        return(self.core.pop())
    def peek(self):
        return(self.core.end.Prev.getData)
    def isEmpty(self):
        return True if self.core.size() == 0 else False
    def size(self):
        return self.core.size()
b = Stack()
print(b.isEmpty())
b.push(15)
b.push("Dog")
print(b.isEmpty())
print(b.size())
print(b.pop())
print(b.pop(),b.isEmpty())

#第二题定义queue
class Queue:
    def __init__(self):
        self.core = UnorderedList()
    def enqueue(self,item):
        self.core.append(item)
    def dequeue(self):
        return(self.core.delete())
    def isEmpty(self):
        return True if self.core.size() == 0 else False
    def size(self):
        return self.core.size()
c = Queue()
print(c.isEmpty())
c.enqueue("dog")
c.enqueue(15)
print(c.size(),c.isEmpty())
print(c.dequeue(),c.size())
print(c.dequeue(),c.isEmpty())