# -*- coding: utf-8 -*-
class UnorderedList:
    def __init__(self):
        self.head = None

    def append(self,item):
        current = self.head
        temp = Node(item)
        if current != None:
            while current.getNext() != None:
                current = current.getNext()
            current.setNext(temp)
        else:
            self.head = temp

    def index(self,item):
        current = self.head
        number = 0
        found = False
        while not found and current != None:
            if current.getData() == item:
                found = True
            else:
                current = current.getNext()
            number = number +1
        if found:
            return number -1
        else:
            raise IndexError('not found')

    def pop(self,pos = -1):
        if pos <0:                #实现用负数取倒数的位置
            pos = pos + len(self)
        current = self.head
        previous = None
        number = 0
        while number < pos:
            previous = current
            current = current.getNext()
            number = number +1
        if previous == None:     #如果链表为空
            self.head = None
        else:
            previous.setNext(current.getNext())
        return current.getData()

    def insert(self,pos,item):
        if pos < -len(self):     #当pos越界时，默认插到第一个或最后一个位置
            pos = -len(self)
        elif pos > len(self):
            pos = len(self)
        elif pos <0:            #实现用负数表示倒数的位置
            pos = pos + len(self)
        current = self.head
        previous = None
        number = 0
        while number < pos:
            previous = current
            current = current.getNext()
            number = number +1
        temp = Node(item)
        if previous == None:    #如果链表为空
            temp.setNext(self.head)
            self.head = temp
        else:
            temp.setNext(current)
            previous.setNext(temp)

    def __str__(self):
        current = self.head
        aList = []
        while current != None:
            aList.append(current.getData())
            current = current.getNext()
        return str(aList)

    def __getitem__(self,n):
        if isinstance(n,int):     #如果n表示整数
            if n >= len(self) or n < -len(self):
                raise IndexError('out of range')
            elif n <0:
                n = n + len(self)
            current = self.head
            number = 0
            while number <n:
                current = current.getNext()
                number = number +1
            return current.getData()

        if isinstance(n,slice):    #如果n表示切片
            start = n.start
            stop = n.stop
            if start >= len(self) or start < -len(self):  #考查start是否合理
                raise IndexError('out of range')
            elif start <0:
                start = start + len(self)
            if stop >= len(self) or stop < -len(self):    #考查stop是否合理
                raise IndexError('out of range')
            elif stop <0:
                stop = stop + len(self)
            current = self.head
            number = 0
            while number < start:
                current = current.getNext()
                number = number +1
            aList = []                          #将切片段储存在一个列表中
            while number < stop:
                aList.append(current.getData())
                current = current.getNext()
                number = number +1
            return aList

    def __len__(self):
        current = self.head
        count = 0
        while current != None:
            current = current.getNext()
            count = count +1
        return count


class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None

    def getData(self):
        return self.data

    def getNext(self):
        return self.next

    def setData(self,newdata):
        self.data = newdata

    def setNext(self,newnext):
        self.next = newnext