# -*- coding: utf-8 -*-
class UnorderedList:
    def __init__(self):
        self.head = None
        self.tail = None

    def add(self,item):
        temp = Node(item)
        if self.isEmpty():
            self.head = temp
            self.tail = temp
        else:
            temp.setNext(self.head)
            self.head.setPrev(temp)
            self.head = temp

    def remove(self,item):
        current = self.head
        found = False
        while not found:
            if current.getData() == item:
                found = True
            else:
                current = current.getNext()
        previous = current.getPrev()
        next = current.getNext()
        if self.head == current or self.tail == current:  #如果item恰位于链首或链尾，特殊处理
            if self.head == current:
                self.head = next
            if self.tail == current:
                self.tail = previous
        else:
            previous.setNext(next)
            next.setPrev(previous)

    def search(self,item):
        current = self.head
        found = False
        while current != None and not found:
            if current.getData() == item:
                found = True
            else:
                current = current.getNext()
        return found

    def size(self):
        current = self.head
        count = 0
        stop = False
        while current != None:
            count = count +1
            current = current.getNext()
        return count

    def isEmpty(self):
        return self.head == None

    def append(self,item):
        temp = Node(item)
        if self.isEmpty():
            self.head = temp
            self.tail = temp
        else:
            temp.setPrev(self.tail)
            self.tail.setNext(temp)
            self.tail = temp

    def index(self,item):
        current = self.head
        number = 0
        found = False
        while not found and current != None:
            if current.getData() == item:
                found = True
            else:
                current = current.getNext()
            number = number +1
        if found:
            return number -1
        else:
            raise IndexError('not found')

    def insert(self,pos,item):
        len = self.size()
        if pos < -len:
            pos = -len
        elif pos > len:
            pos = len
        elif pos <0:
            pos = pos + len
        current = self.head
        previous = None
        number = 0
        while number < pos:
            previous = current
            current = current.getNext()
            number = number +1
        temp = Node(item)
        if  previous == None or current == None:   #如果item恰位于链首或链尾，特殊处理
            if previous == None:
                temp.setNext(self.head)
                current.setPrev(temp)
                self.head = temp
            else:
                temp.setPrev(self.tail)
                previous.setNext(temp)
                self.tail = temp
        else:
            temp.setPrev(previous)
            temp.setNext(current)
            previous.setNext(temp)
            current.setPrev(temp)

    def pop(self,pos = -1):
        if pos <0:
            pos = pos + self.size()
        current = self.head
        number = 0
        while number < pos:
            current = current.getNext()
            number = number +1
        previous = current.getPrev()
        next = current.getNext()
        if self.head == current or self.tail == current:
            if self.head == current:
                self.head = next
            if self.tail == current:
                self.tail = previous
        else:
            previous.setNext(next)
            next.setPrev(previous)
        return current.getData()


class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
        self.prev = None

    def getData(self):
        return self.data

    def getNext(self):
        return self.next

    def getPrev(self):
        return self.prev

    def setData(self,newdata):
        self.data = newdata

    def setNext(self,newnext):
        self.next = newnext

    def setPrev(self,newprev):
        self.prev = newprev
