# -*- coding: utf-8 -*-
class Node:
    def __init__(self,initdata):
        self.data=initdata
        self.next=None
        self.prev=None                          #为节点类定义一个新的prev变量
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def getPrev(self):                          #新增函数
        return self.prev
    def setData(self,newdata):
        self.data=newdata
    def setNext(self,newnext):
        self.next=newnext
    def setPrev(self,newprev):                  #新增函数
        self.prev=newprev
class UnorderedList:
    def __init__(self):
        self.head=None
        self.tail=None                          #为无序列表类定义一个新的tail变量
    def add(self,item):
        temp=Node(item)
        temp.setNext(self.head)
        self.head=temp
        if self.tail==None:                     #维持tail在列表末端
            self.tail=temp
        else:
            temp.getNext().setPrev(temp)         #维持prev指向前一个元素
    def isEmpty(self):
        return self.head==None
    def size(self):
        current=self.head
        count=0
        while current!=None:
            count+=1
            current=current.getNext()
        return count
    def search(self,item):
        current=self.head
        found=False
        while current!=None and not found:
            if current.getData()==item:
                found=True
            else:
                current=current.getNext()
        return found
    def remove(self,item):                      #利用prev可免去对previous的定义
        current=self.head
        found=False
        while not found:
            if current.getData()==item:
                found=True
            else:
                current=current.getNext()
        if current.getPrev()==None:             #但须维持prev指向前一个元素
            self.head=current.getNext()
        else:
            current.getPrev().setNext(current.getNext())
        if current.getNext()==None:
            self.tail=current.getPrev()
        else:
            current.getNext().setPrev(current.getPrev())
    def append(self,item):                      #利用tail可免去对列表最后一个元素的寻找
        temp=Node(item)
        if self.head!=None:
            self.tail.setNext(temp)
            temp.setPrev(self.tail)
        else:
            self.head=temp
        self.tail=temp
    def index(self,item):
        current=self.head
        found=False
        count=0
        while not found:
            if current.getData()==item:
                found=True
            else:
                current=current.getNext()
                count+=1
        return count
    def pop(self):                              #利用tail可免去对列表最后一个元素的寻找
        pop=self.tail.getData()
        if self.head.getNext()==None:
            self.head=None
            self.tail=None
        else:
            self.tail=self.tail.getPrev()
            self.tail.setNext(None)
        return pop
    def pop2(self,pos):                         #利用prev可免去对previous的定义
        current=self.head
        for i in range(pos):
            current=current.getNext()
        if current.getPrev()==None:             #但须维持prev指向前一个元素
            self.head=current.getNext()
        else:
            current.getPrev().setNext(current.getNext())
        if current.getNext()==None:
            self.tail=current.getPrev()
        else:
            current.getNext().setPrev(current.getPrev())
        return current.getData()
    def insert(self,pos,item):
        temp=Node(item)
        if pos==0:
            temp.setNext(self.head)
            self.head=temp
            if self.tail==None:                 #维持tail在列表末端
                self.tail=temp
            else:
                temp.getNext().setPrev(temp)
        else:
            current=self.head
            for i in range(1,pos):
                current=current.getNext()
            temp.setNext(current.getNext())
            if temp.getNext()!=None:
                temp.getNext().setPrev(temp)
            current.setNext(temp)
            temp.setPrev(current)
    def __str__(self):
        a='['
        if self.head!=None:
            current=self.head
            while current.getNext()!=None:
                a=a+str(current.getData())+','
                current=current.getNext()
            a=a+str(current.getData())
        a=a+']'
        return a
    def __getslice__(self,startpos,endpos):
        new=UnorderedList()
        current=self.head
        for i in range(startpos):
            current=current.getNext()
        for i in range(startpos,endpos):
            new.append(current.getData())
            current=current.getNext()
        return new
class Stack:
    def __init__(self):
        self.items=UnorderedList()
    def isEmpty(self):
        return self.items.isEmpty()
    def push(self,item):                        #在双向链表中，可用链表尾做栈顶，可减少条件判断的次数
        self.items.append(item)
    def pop(self):                              #pop须作出对应更改
        return self.items.pop()
    def peek(self):
        return self.items.tail.getData()
    def size(self):
        return self.items.size()
class Queue:
    def __init__(self):
        self.items=UnorderedList()
    def isEmpty(self):
        return self.items.isEmpty()
    def enqueue(self,item):                     #以链表头做队尾
        self.items.insert(0,item)
    def dequeue(self):                          #以链表尾做队首
        return self.items.pop()
    def size(self):
        return self.items.size()
