# -*- coding: utf-8 -*-
class Node:                                       #定义节点类
    def __init__(self,initdata):
        self.data=initdata
        self.next=None
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self,newdata):
        self.data=newdata
    def setNext(self,newnext):
        self.next=newnext
class UnorderedList:                              #定义无序列表类
    def __init__(self):
        self.head=None
    def add(self,item):                           #不指定位置添加
        temp=Node(item)
        temp.setNext(self.head)
        self.head=temp
    def isEmpty(self):                            #判断列表是否为空
        return self.head==None
    def size(self):                               #得到列表内元素的个数
        current=self.head
        count=0
        while current!=None:
            count+=1
            current=current.getNext()
        return count
    def search(self,item):                        #判断一个元素是否在列表中
        current=self.head
        found=False
        while current!=None and not found:
            if current.getData()==item:
                found=True
            else:
                current=current.getNext()
        return found
    def remove(self,item):                        #从列表中删除指定元素
        current=self.head
        previous=None
        found=False
        while not found:
            if current.getData()==item:
                found=True
            else:
                previous=current
                current=current.getNext()
        if previous==None:
            self.head=current.getNext()
        else:
            previous.setNext(current.getNext())
    def append(self,item):                        #在列表末添加元素（作业）
        temp=Node(item)
        if self.head!=None:                       #若列表不为空，则找出列表中最后一个元素，在其后插入
            current=self.head
            while current.getNext()!=None:
                current=current.getNext()
            current.setNext(temp)
        else:                                     #若列表为空，将表头指向新元素
            self.head=temp
    def index(self,item):                         #求元素的索引值，假设列表中存在该元素（作业）
        current=self.head
        found=False
        count=0
        while not found:                         #寻找目标元素并记录寻找次数，从0开始计数
            if current.getData()==item:
                found=True
            else:
                current=current.getNext()
                count+=1
        return count                             #返回寻找次数
    def pop(self):                               #删除列表中最后一个元素，假设列表不为空（作业）
        current=self.head
        previous=None
        while current.getNext()!=None:          #寻找列表中最后一个元素
            previous=current
            current=current.getNext()
        if previous==None:                      #若列表中只有一个元素，将列表改为空表
            self.head=None
        else:                                   #若列表中不只有一个元素，将倒数第二个元素作为最后一个元素
            previous.setNext(None)
        return current.getData()                #返回被删除元素中的数据
    def pop2(self,pos):                         #从指定位置删除元素，假设索引值小于等于列表长度且列表不为空（非作业）
        current=self.head
        previous=None
        for i in range(pos):                    #找到指定位置
            previous=current
            current=current.getNext()
        if previous==None:                      #若指定位置为0，将表头指向第二个元素（或None）
            self.head=current.getNext()
        else:                                   #若指定位置不为0，将前一个元素指向当前元素的下一个元素（或None）
            previous.setNext(current.getNext())
        return current.getData()                #返回被删除元素中的数据
    def insert(self,pos,item):                  #在指定位置插入元素，假设索引值小于等于列表长度（作业）
        temp=Node(item)
        if pos==0:                              #若指定位置为0，仿照add方法插入（若初始为空列表，则必为此情况）
            temp.setNext(self.head)
            self.head=temp
        else:                                   #若指定位置不为0
            current=self.head
            for i in range(1,pos):              #找到指定位置，插入新元素
                current=current.getNext()
            temp.setNext(current.getNext())
            current.setNext(temp)
    def __str__(self):                          #给出无序列表的字符串表示，假设列表中每一个元素都存在字符串表示（作业）
        a='['                                   #用【】括起
        if self.head!=None:
            current=self.head
            while current.getNext()!=None:
                a=a+str(current.getData())+','  #不同元素以，间隔
                current=current.getNext()
            a=a+str(current.getData())
        a=a+']'
        return a
    def __getslice__(self,startpos,endpos):     #取出列表中指定区域间的元素，假设假设索引值小于等于列表长度（作业）
        new=UnorderedList()
        current=self.head
        for i in range(startpos):               #找出起始位置
            current=current.getNext()
        for i in range(startpos,endpos):        #将起始位置与终止位置间的元素放入一个新列表中
            new.append(current.getData())
            current=current.getNext()
        return new                              #返回该新列表（若终止位置大于起始位置，新列表为空）
class Stack:                                    #用链表定义栈
    def __init__(self):
        self.items=UnorderedList()
    def isEmpty(self):
        return self.items.isEmpty()
    def push(self,item):                         #考虑到时间复杂度，用链表头作为栈顶
        self.items.insert(0,item)
    def pop(self):                               #要从链表头删除元素，需用一个新的函数，在链表类中已给出定义
        return self.items.pop2(0)
    def peek(self):
        return self.items.head.getData()
    def size(self):
        return self.items.size()
class Queue:                                    #用链表定义队列
    def __init__(self):
        self.items=UnorderedList()
    def isEmpty(self):
        return self.items.isEmpty()
    def enqueue(self,item):                     #以链表头做队尾
        self.items.insert(0,item)
    def dequeue(self):                          #以链表尾做队首
        return self.items.pop()
    def size(self):
        return self.items.size()