class Node():
    def __init__(self,initdata):        #定义node和data，next及其方法
        self.data=initdata
        self.next=None
    def getData(self):
        return  self.data
    def getNext(self):
        return  self.next
    def setData(self,newdata):
        self.data=newdata
    def setNext(self,newnext):
        self.next=newnext

class UnorderedList():
    def __init__(self):
        self.head = None
    def isEmpty(self):
        return self.head==None
    def add(self,item):
        temp=Node(item)
        temp.setNext(self.head)
        self.head=temp
    def size(self):
        current=self.head
        count=0
        while current!=None:
            count=count+1
            current=current.getNext()
        return count
    def append(self,item):
        temp=Node(item)
        if self.isEmpty():
            temp.setNext(self.head)
            self.head=temp          #若为空表，将添加的元素设为第一个元素
        else:
            current=self.head
            while current.getNext()!=None:
                current=current.getNext()   #遍历链表
            current.setNext(temp)           #此时current为链表最后的元素
    def index(self,item):
        current=self.head
        num=0           #用于计数，获得其index
        while current!=None:
            if item==current.getData():         #若等于，则说明已经查找到，直接输出num
                return num
            else:
                num=num+1                       #若不等于，则下一个，nun加一
                current=current.getNext()
            if num>self.size()-1:               #若遍历链表都找不到，则返回"not found"
                return "not found"
    def pop(self):
        current=self.head
        if self.size()>1:               #如果链表不止一个值，则遍历链表，直到倒数第二个
            for i in range(self.size()-2):
                current=current.getNext()
            tempcur=current.getNext()       #获得最后一个node，将其存为tempcur
            current.setNext(None)           #把最后一个节点剔除
            return tempcur.getData()        #将暂存的tempcur的值返回
        elif self.size()==1:            #如果只有一个，直接设置head为None，返回current的值
            self.head=None
            return current.getData()
        elif self.size()==0:
            return  "no value,don't pop"      #若链表为空，则返回提示


    def getAll(self):       #获得整个链表
        current = self.head
        tempList=list()     #用于存放每一个节点的值
        if current == None:
            return "this is an empty list"
        while current is not None:
            tempList.append(current.getData())      #不为空，遍历链表，把每个节点的值存入list中，返回
            current = current.next
        return tempList


    def insert(self,num,item):
        temp = Node(item)
        if num>self.size()-1 or num<0:      #溢出的情况
            print("out of range")
        if num==0:              #插入第一个，相当于直接add
            self.add(item)
        else:                   #否则，遍历至num，直接插入，和add类似，只是要考虑next要指向后一个，以及前一个的next要指向当前插入的值
            current=self.head
            for i in range(num-1):
                current=current.getNext()
            post=current.getNext()
            temp.setNext(post)
            current.setNext(temp)

    def ___str___(self):        #我的理解是。。。这一个函数能把链表转化成字符串
        if self.size()==0:
             return "this unorderedlist is None"
        else:
            current=self.head
            temp=''
            while current!=None:            #和之前的getALL一样，遍历链表，把每一个节点的值加到temp中就行
                temp=temp+str(current.getData())
                current=current.getNext()
            return temp
    def __getslice__(self,num1,num2):           #切片，我的问题是做不到[:1]，一定要输入两个参数，也就是说第一个切不到，还求助教下次能讲讲。。。
        current=self.head
        templis=list()
        if num1<0 or num2>self.size()-1:        #考虑溢出的情况
            return "out of range"
        else:
            for i in range(num1):               #先数到第一个数的current，保存
                current=current.getNext()
            for i in range(num2-num1):              #从第一个数的current起，数到第二个数的current，其中的data全部存入templis列表中
                current=current.getNext()
                templis.append(current.getData())
            return templis              #返回列表






'''temp=UnorderedList()  #检验代码块在这里，助教可以试试 ：-）
temp.add(1)
temp.add(2)
temp.add(3)
temp.add(4)
temp.add(5)
temp.add(6)
temp.insert(3,233)
print(temp.pop())
print(temp.pop())
print(temp.___str___())
print(temp.getAll())
print(temp.index(233))'''



