class Node():
    def __init__(self,initdata):        #在Node类中添加Prev，相应的也要添加获取和设置prev的两个方法
        self.prev=None
        self.next=None
        self.data=initdata
    def getData(self):
        return  self.data
    def getNext(self):
        return  self.next
    def getPrev(self):
        return self.prev
    def setData(self,newdata):
        self.data=newdata
    def setNext(self,newnext):
        self.next=newnext
    def setPrev(self,newprev):
        self.prev=newprev

class UnorderedList():
    def __init__(self):             #添加tail用于从后往前数
        self.head=None
        self.tail=None
    def isEmpty(self):
        return self.tail==None  #检验是否为空，这里用tail和head最后的结果是一样的，因为只要插入一个值，head和tail就会被替换
    def add(self,item):
        temp = Node(item)
        temp.setNext(self.head)
        if self.tail is None:       #如果尾部是空，就不能让尾部的prev指向temp，因为此时尾部没有prev
            temp.setPrev(self.tail)
            self.tail = temp
        else:                       #如果尾部不为空，那么说明尾部已经是一个node，此时可以让其prev指向temp
            self.head.setPrev(temp)
        self.head = temp             #从前往后加，每次加入的Node将会成为头

    def append(self,item):
        temp = Node(item)
        temp.setPrev(self.tail)
        if self.head is None:          #和上面一样，如果头部为空，则没有next，无法指向当前temp
            temp.setNext(self.head)
            self.head=temp
        else:                           #不为空，则指向temp
            self.tail.setNext(temp)
        self.tail=temp                  #从后往前加，每次加入，尾部设置为空

    def size(self):
        current=self.head               #和第一题是一样的，不过这里如果将head替换成tail，需要在下面把current改为getPrev（）
        count=0
        while current!=None:
            count=count+1
            current=current.getNext()
        return count
    def getAll(self):                   #获得链表中所有元素，以列表的形式输出
        current=self.tail               #同样地，这里也能把tail改为head，下面相应的地方改掉就行
        templis=list()
        while current!=None:
            templis.insert(0,current.getData())
            current=current.getPrev()
        return templis
    def insert(self,num,item):
        if num<0 or num >self.size()-1:     #特殊情况，溢出
            print("out of range")
        elif num==0:                        #插入第0个，直接用add
            self.add(item)
        elif num==self.size()-1:            #插入最后一个，直接用pop
            self.append(item)
        else:
            current=self.head
            for i in range(num-1):      #插入其他地方，让current停留在插入的前一个
                current=current.getNext()
            tempcur=current.getNext()      #用一个tempcur存放下一个current
            temp=Node(item)
            temp.setPrev(current)           #把temp的prev指向前一个current
            current.setNext(temp)            #把前一个current的next指向temp
            tempcur.setPrev(temp)           #利用刚刚存放的tempcur，将其prev指向temp
            temp.setNext(tempcur)           #将temp的next指向下一个current





'''a=UnorderedList()  #检验代码块在这里，助教可以试试 ：-）
a.add(2)
a.add(3)
a.add(4)
a.add(5)
a.add(6)
a.add(7)
a.add(444)
a.append(8)
a.append(9)
a.append(100)
a.insert(1,'nimade')
print(a.size())
print(a.getAll())
print(a.isEmpty())'''