class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self,newdata):
        self.data = newdata
    def setNext(self,newnext):
        self.next = newnext

class UnorderedList:
    def __init__(self):
        self.head = None
    def add(self,item):
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp
    def size(self):
        current = self.head
        count = 0
        while current != None:
            count = count + 1
            current = current.getNext()
        return count
    def append(self,item):
        temp = Node(item)
        current = self.head
        previous = None
        while current != None:
            previous = current
            current = current.getNext()
        if previous == None:
            self.head = temp
        else:
            previous.setNext(temp)
    def index(self,item):
        current = self.head
        count = 0
        while current!= None:
            if current.getData() == item:
                return count
            else:
                current = current.getNext()
                count = count + 1
        return False
    def pop(self):
        current = self.head
        previous = None
        while current.getNext()!= None:
            previous = current
            current = current.getNext()
        if previous == None:
            self.head = None
        else:
            previous.setNext(None)
        return current.getData()
    def insert(self,num,item):
        temp = Node(item)
        current = self.head
        count = 0
        previous = None
        while count != num:
            previous = current
            current = current.getNext()
            count = count + 1
        if num == 0:
            temp.setNext(current)
            self.head = temp
        else:
            temp.setNext(current)
            previous.setNext(temp)
    def __str__(self):
        A=''
        current = self.head
        while current != None:
            A= A + str(current.getData())
            current = current.getNext()
        return A
    def __getslice__(self,num1,num2):
        s=UnorderedList()
        current=self.head
        count = 0
        while count != num2:
            if count >= num1:
                s.append(current.getData())
            current = current.getNext()
            count = count + 1
        return s

class Stack:
    def __init__(self):
        self.items = UnorderedList()
    def isEmpty(self):
        return self.items.head == None
    def push(self,item):
        self.items.append(item)
    def pop(self):
        return self.items.pop()
    def peek(self):
        current = self.items.head
        previous = None
        while current != None:
            previous = current
            current = current.getNext()
        return previous.getData()
    def size(self):
        return self.items.size()

class Queue:
    def __init__(self):
        self.items = UnorderedList()
    def isEmpty(self):
        return self.items.head == None
    def enqueue(self,item):
        self.items.add(item)
    def dequeue(self):
        return self.items.pop()
    def size(self):
        return self.items.size()

    
    
